var port = null

function sendResponse(response) {
	var receiveBtn = document.getElementById('amplink-receive')
	receiveBtn.setAttribute("response", JSON.stringify(response))
	var click = new Event('click')
	receiveBtn.dispatchEvent(click)
}

function initialize() {
	// dynamic insert some html.
	var div = document.getElementById("amplink-msg")
	if (div) {
		div.setAttribute('extension-loaded', true)
	}

	var receive = document.getElementById("amplink-receive")
  if (receive) {
    receive.setAttribute("version", chrome.runtime.getManifest().version);
  }
}

document.onclick = function(e) {
	var el = e.target
	if (el.id == "amplink-send") {
		var message = JSON.parse(el.getAttribute("action"))
		if (!port) {
			port = chrome.runtime.connect()
			port.onMessage.addListener(function(msg) {
				//console.log('got message from extension: ' + JSON.stringify(msg));
				sendResponse(msg)
			})
			port.onDisconnect.addListener(function() {
				//console.log("extension port closed.");
				port = null
			})
		}
		//console.log('posting message to extension: ' + JSON.stringify(message));
		port.postMessage(message)
	}
}
initialize()
